#include "gtim.h"

uint32_t Gtim_value = 31249;

void GTIM_Init(void)   
{
	  GTIM_InitTypeDef GTIM_InitStruct;

	  //GTIMʱ
	  REGBITS_SET( CW_SYSCTRL->APBEN1, SYSCTRL_APBEN1_GTIM1_Msk);

	  GTIM_InitStruct.Mode = GTIM_MODE_TIME;
	  GTIM_InitStruct.OneShotMode = GTIM_COUNT_CONTINUE;
	  GTIM_InitStruct.Prescaler = GTIM_PRESCALER_DIV256;
	  GTIM_InitStruct.ReloadValue = Gtim_value;        //1s.
	  GTIM_InitStruct.ToggleOutState = ENABLE;

	  GTIM_TimeBaseInit(CW_GTIM1, &GTIM_InitStruct);
	  GTIM_ITConfig(CW_GTIM1, GTIM_IT_OV, ENABLE);
		
		NVIC_SetPriority(GTIM1_IRQn, 0x03);
	  NVIC_ClearPendingIRQ(GTIM1_IRQn);
	  NVIC_EnableIRQ(GTIM1_IRQn);
		GTIM_Cmd(CW_GTIM1, ENABLE);
}
