#include "main.h"
#include "system_cw32f030.h"
#include "interrupts_cw32f030.h"
#include "cw32f030_systick.h"
#include "cw32f030_rcc.h"
#include "cw32f030_gpio.h"
#include "cw32f030_adc.h"
#include "cw32f030_gtim.h"
#include "cw32f030_uart.h"
#include "bmp.h"
#include "oled.h"
#include "adc.h"
#include "uart.h"
#include "gtim.h"

uint16_t valueAdc;
uint32_t valueAdcAcc;
volatile uint8_t gFlagIrq;
uint16_t gCntEoc = 0;
uint8_t cntSample;
float fTsDegree;

void RCC_Configuration(void)
{
  //SYSCLK = HSI = 8MHz = HCLK = PCLK
  RCC_HSI_Enable(RCC_HSIOSC_DIV6);
  //ʱʹ
  RCC_AHBPeriphClk_Enable(DEBUG_USART_GPIO_CLK | RCC_AHB_PERIPH_GPIOF, ENABLE);
  DEBUG_USART_APBClkENx(DEBUG_USART_CLK, ENABLE);
}

int main(void)
{		
    RCC_HSI_Enable(RCC_HSIOSC_DIV6);
		RCC_Configuration();
		UART_Configuration();
    ADC_PortInit();
		ADC_Configuration();
    GTIM_Init();
		OLED_Init();
		OLED_DisplayTurn(1);
		OLED_Refresh();
	
    while(1)
    {
    	while(!(gFlagIrq & ADC_ISR_EOC_Msk));
				USART_SendData(DEBUG_USARTx,1);
        gFlagIrq = 0;
			  PF06_TOG();
        valueAdc = ADC_GetConversionValue();
        ADC_GetTsVref2V5(&fTsDegree);
    }
}

