#include "c8051f020.h"
#include "ADC.h"
#include "LCD.h"

extern unsigned long SYSCLK; 
extern unsigned int Voltage[1500];
unsigned int ADC0_Value;
unsigned int datanum = 0;
unsigned int datanum2 = 0;

/**
 * ADC0ʼ	
 */ 
void ADC0_Init(void)
{
  AMX0CF = 0; //AIN1ͨ
	AMX0SL = 1;
 
  ADC0CF = ((SYSCLK/SAR0_CLK - 1) << 3);  //ADCתʱ
	ADC0CF &= ~(BIT2 + BIT1 + BIT0);        //PGAΪ1

	ADC0CN &= ~(BIT6 + BIT5 + BIT3 + BIT1 + BIT0); //ADCʹʱתڼ֮һֱڸٷʽ  
											       //ת־ 㴰ڱȽжϱ־ Ҷ
	ADC0CN |= BIT2;	                               //ʱ3ADC0ת

	REF0CN &= ~BIT4; //οѹȡVREF0
	REF0CN |= BIT1 + BIT0; //

	EIE2 |= BIT1; //ADCתж
	EA = 1;

	ADC0CN |= BIT7; //ʹADC0
}

/**
 * رADC0	
 */
void ADC0_Disable()
{
	ADC0CN &= ~BIT7; //رADC0	
}

/**
 * ADC0	
 */
void ADC0_Enable()
{
	ADC0CN |= BIT7; //ʹADC0
}

/**
 * ʼʱ3
 * counts: ʾʱҪʱӸ	
 */
void Timer3_Init(unsigned int counts)	
{
	TMR3CN &= ~(BIT7 + BIT2 + BIT0);  //㶨ʱ3־ ʱرնʱ3 ʱ3ʱT3M
	TMR3CN &= ~BIT1;       	   //ʱ3ʱΪϵͳʱ/12
	TMR3RLL = ((65536 - counts) & 0xff);
	TMR3RLH = (((65536 - counts) >> 8) & 0xff); //㶨ʱ3ؼĴֵ
//  TMR3RLL = 0xA0;
//  TMR3RLH = 0xFF;
	TMR3L = TMR3RLL;
	TMR3H = TMR3RLH; //趨ֵ
	EIE2 &= ~BIT0; //close
	EA = 1;
	TMR3CN |= BIT2; //ʱ3
} 

void Timer3_Init2(unsigned int counts)	
{
	TMR3CN &= ~(BIT7 + BIT2 + BIT0);  //㶨ʱ3־ ʱرնʱ3 ʱ3ʱT3M
	TMR3CN |= BIT1;       	   //ʱ3ʱΪϵͳʱ
	TMR3RLL = ((65536 - counts) & 0xff);
	TMR3RLH = (((65536 - counts) >> 8) & 0xff); //㶨ʱ3ؼĴֵ
//  TMR3RLL = 0xA0;
//  TMR3RLH = 0xFF;
	TMR3L = TMR3RLL;
	TMR3H = TMR3RLH; //趨ֵ
	EIE2 |= BIT0; //open
	EA = 1;
	TMR3CN |= BIT2; //ʱ3
}  

/**
 * ADC0תжڳ	
 */
void ADC0_INT_ISR(void) interrupt 15
{
    if(AD0INT == 1)
    {
				if( RT_flag == 1 )                                               //Real-time storage and real-time display
				{
						if(datanum <= 127&& Wait_flag == 0)
						{
								Voltage[datanum] = (ADC0H << 8) + ADC0L;
								datanum++;
						}
						else if (datanum >127) 
						{
								Wait_flag = 1;
								datanum = 0;
						}
						DAC0L = ADC0L;
						DAC0H = ADC0H;
				}
				else																														//Single storage, continuous and stable display
				{
						if(datanum <= 1500)
						{
								Voltage[datanum] = (ADC0H << 8) + ADC0L;
								datanum++;
						}
				}
     }
}

void Timer3_INT_ISR(void) interrupt 14
{
	if(TMR3CN & BIT7)
	{
		TMR3CN &= ~BIT7;
		DAC0L = Voltage[datanum2] & 0xFF;
		DAC0H = (Voltage[datanum2] >> 8) & 0xFF;
		datanum2++;
		if(datanum2 >= 1500) datanum2 = 0;
	}
}
